PRO Overplot
;This program takes the data from any of the programs Optical_trap_force.pro, clipdata1.pro or clipdata2.pro and plots several data sets on the same axis.
;;Allows easy comparison of force data for different optical powers
;
;Access the data files  to be plotted
filters = ['*.DAT'] 
filenamelist = DIALOG_PICKFILE(/READ,FILTER=filters,/MULTIPLE_FILES)
print,'List of Files Accessed =',filenamelist
Number_of_files=SIZE(filenamelist,/N_ELEMENTS)
PRINT,'Number of Files accessed =',Number_of_files
first_run=0
FOR file_itr=0,Number_of_files-1 do begin
    filename=filenamelist(file_itr)  
    OPENR,lun,filename,/GET_LUN
    itr=0
    tempcomb=fltarr(300000)
       ;Reads entire file sequentially into tempcomb to create array
WHILE(not EOF(lun)) do begin
    READU,lun,oX
    tempcomb(itr)=oX
    itr=itr+1
ENDWHILE
;deccimate (alternate element) array into two arrays, X=Distance and Y=Force arrays
    halfsize=(itr-1)/2
    X=tempcomb(0:halfsize)
    Y=tempcomb(halfsize+1:itr-1)
    Close,lun
    
    ;set up colour table to enable different coloured lines for overplotting
    ;
    Device, Decomposed=0
    ;ELEMENT[ 0,   1,   2,   3,   4,   5,   6,   7,   8,   9 ] COLOUR Label
    RED =   [0.5, 0.2, 1.0, 0.0, 0.0, 1.0, 1.0, 0.0, 0.0, 0.0];Specify the red component of each color:
    GREEN = [0.5, 0.2, 0.0, 1.0, 0.0, 1.0, 0.0, 1.0, 0.0, 0.5];Specify the green component of each color:
    BLUE =  [0.5, 0.2, 0.0, 0.0, 1.0, 0.0, 1.0, 1.0, 0.5, 0.0];Specify the blue component of each color:
    ;Available COLOURS          
    ;0=1 RED+1 GREEN+1BLUE  =  GREY Background of plot                     ;plot  = white dotted line                 
    ;1=0.2 RED+0.2 GREEN+0.2 BLUE  =  DARK GREY (ALMOST BLACK)             ;OPLOT 1 = Dark Grey                                                                  
    ;2=RED                                                                 ;OPLOT 2 = RED
    ;3=Green                                                               ;OPLOT 3 = Green
    ;4=BLUE                                                                ;OPLOT 4 = Blue 
    ;5=RED+GREEN=YELLOW                                                    ;OPLOT 5 = Yellow                         
    ;6=RED+BLUE=PURPLE                                                     ;OPLOT 6 = Purple                     
    ;7=BLUE+GREEN=CYAN                                                     ;OPLOT 7 = CYAN                      
    ;8=0.5 BLUE=DARK BLUE                                                  ;OPLOT 8 = Dark Blue                    
    ;9=0.5 GREEN=DARK GREEN                                                ;OPLOT 9 = Dark Green     
                                                                         
    ;or add more combinations by using different linestyles for each colour, e.g. solid green and dotted green.....Yet to be done
    ;took white out of the colour table as I was getting two plot lines of the same colour 
    ;as plot would use white as default then OPLOT 1 would use white also therefore changed it to dark grey
    numbcolours=Number_of_files
    ;Load the first EIGHT elements of the colour table
    TVLCT, 255 * RED, 255 * GREEN, 255 * BLUE
  
    IF file_itr EQ 0 THEN BEGIN
    WINDOW,28,TITLE='Force Distance Plot Tip 94a Insertion 10 Degrees 500 FPS',XSIZE=1000,YSIZE=720,RETAIN=2
    PLOT,X,Y,CHARSIZE=1.35,TITLE='OTF1_Force/Distance Tip 94a Insertion 10 Degrees 500 FPS',XTITLE='Metres',YTITLE='Newtons',THICK=2.5,POS=[0.15,0.15,0.95,0.95],xCHARSIZE=1.35,yCHARSIZE=1.35,CHARTHICK=1.0,LINESTYLE=2,YRANGE =[Min(Y,i),Max(50e-12)] 
    PRINT,'Total Distance Travelled=',MAX(X,i)-MIN(X,i)
    ENDIF ELSE BEGIN 
    OPLOT,X,Y,LINESTYLE=0,COLOR=file_itr,THICK=2.5
    PRINT,'MAXIMUM FORCE =',MAX(Y,i)
    PRINT,'Total Distance Travelled=',MAX(X,i)-MIN(X,i)
    ENDELSE
    ENDFOR
im=tvrd(true=3) ;im is an array
write_jpeg,'OTF1_Tip94a_plot.jpeg',im,quality=100,true=3
PRINT,'finished'
end